#include <iostream>
#include <cassert>
#include <stdexcept>
using namespace std;

class YearValueError : public logic_error {
  public:
    YearValueError(const char reason[]): logic_error(reason) {}
};	
float calc1(float value, int years) {
    return value * (100 / (float) years);
}
float calc2(float value, int years) {
    if (years <= 0) return 0;
    return value * (100 / (float) years);
}
float calc3(float value, int years) {
    assert(years > 0);
    return value * (100 / (float) years);
}
float calc4(float value, int years) {
    if (years <= 0) {
	throw logic_error("parametro 'years' invalido");
    }
    return value * (100 / (float) years);
}
float calc5(float value, int years) throw (logic_error, YearValueError) {
    if (years <= 0) {
	// pode dar problema pois esta lancando uma excecao
	// nao prevista e pode nao ser capturada
	// throw runtime_error("parametro 'years' invalido (runtime)");
	throw YearValueError("parametro 'years' invalido");
    }
    return value * (100 / (float) years);
}

int main (int argc, char*argv[]) {
 
    float result = -1, value1 = 9.0f;    
    int years;
    //result = calc1(value1, 0);
    do {
      cout << "Anos: ";
      cin >> years;
      try {
	  result = calc5(value1, years);
	  cout << "Resultado: " << result << endl;
      } catch (YearValueError & e) {
	  cout << "Excecao 1 capturada: " << e.what() << endl;
	  cout << "O calculo so pode ser feito com n.o de anos > 0 "<< endl;
      } catch (logic_error & e) {
	  cout << "Excecao 2 capturada: " << e.what() << endl;
      } catch (runtime_error & e) {
	  cout << "Excecao 3 capturada (runtime): " << e.what() << endl;
      }
      
    } while (result == -1);
    
    cout << "Fim do programa" << endl;
    return 0;
}
